// *****************************************************************************
// Source code for the Hello World Dialog Example Add-On
// API Development Kit 21; Mac/Win
//
// Namespaces:			Contact person:
//		-None-					Tibor Lorántfy (tlorantfy@graphisoft.com)
//
// [SG compatible] - Yes
// *****************************************************************************


// ---------------------------------- Includes ---------------------------------

#include	"APIEnvir.h"
#include	"ACAPinc.h"					// also includes APIdefs.h

#include	"HelloWorldDialog.hpp"


// -----------------------------------------------------------------------------
// Show Dialog
// -----------------------------------------------------------------------------

static void	ShowDialog ()
{
	HelloWorldDialog dialog;
	dialog.Invoke ();
}


// -----------------------------------------------------------------------------
// Handles menu commands
// -----------------------------------------------------------------------------

GSErrCode __ACENV_CALL MenuCommandHandler (const API_MenuParams *menuParams)
{
	switch (menuParams->menuItemRef.menuResID) {
		case 32500:
			switch (menuParams->menuItemRef.itemIndex) {
				case 1:		ShowDialog ();		break;
				default:						break;
			}
			break;
		default:
			break;
	}

	return NoError;
}		// MenuCommandHandler


// =============================================================================
//
// Required functions
//
// =============================================================================

// -----------------------------------------------------------------------------
// CheckEnvironment
//		Dependency definitions
// -----------------------------------------------------------------------------

API_AddonType	__ACENV_CALL	CheckEnvironment (API_EnvirParams* envir)
{
	RSGetIndString (&envir->addOnInfo.name, 32000, 1, ACAPI_GetOwnResModule ());
	RSGetIndString (&envir->addOnInfo.description, 32000, 2, ACAPI_GetOwnResModule ());

	return APIAddon_Normal;
}		// CheckEnvironment


// -----------------------------------------------------------------------------
// RegisterInterface
//		Interface definitions
// -----------------------------------------------------------------------------

GSErrCode	__ACENV_CALL	RegisterInterface (void)
{
	GSErrCode err = ACAPI_Register_Menu (32500, 32510, MenuCode_UserDef, MenuFlag_Default);
	if (err != NoError)
		ACAPI_WriteReport ("RegisterInterface() ACAPI_Register_Menu failed\n", false);

	return err;
}		// RegisterInterface


// -----------------------------------------------------------------------------
// Initialize
//		Called when the Add-On has been loaded into memory
//		to perform an operation
// -----------------------------------------------------------------------------

GSErrCode	__ACENV_CALL Initialize	(void)
{
	GSErrCode err = ACAPI_Install_MenuHandler (32500, MenuCommandHandler);
	if (err != NoError)
		ACAPI_WriteReport ("Initialize() ACAPI_Install_MenuHandler failed\n", false);

	return err;
}		// Initialize


// -----------------------------------------------------------------------------
// FreeData
//		Called when the Add-On is going to be unloaded
// -----------------------------------------------------------------------------

GSErrCode __ACENV_CALL	FreeData (void)
{
	return NoError;
}		// FreeData
